package gregtechmod.loaders.postload;

import gregtechmod.api.GregTech_API;
import gregtechmod.api.enums.GT_ConfigCategories;
import gregtechmod.api.enums.Materials;
import gregtechmod.api.enums.OrePrefixes;
import gregtechmod.api.util.GT_Log;
import gregtechmod.api.util.GT_ModHandler;
import gregtechmod.api.util.GT_OreDictUnificator;
import gregtechmod.api.util.GT_Utility;
import gregtechmod.common.items.GT_MetaItem_Cell;
import gregtechmod.common.items.GT_MetaItem_Component;
import gregtechmod.common.items.GT_MetaItem_Dust;
import gregtechmod.common.items.GT_MetaItem_Material;
import gregtechmod.common.items.GT_MetaItem_SmallDust;

import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;

public class GT_MachineRecipeLoader implements Runnable {
	@Override
	public void run() {
        GT_Log.out.println("GT_Mod: Adding non-OreDict Machine Recipes.");
        
        ItemStack tStack, tStack2;
        
        try {
        	GT_Utility.removeSimpleIC2MachineRecipe(null, (Map)GT_Utility.callMethod(GT_Utility.getFieldContent(ic2.api.recipe.Recipes.class, "metalformerExtruding", true, false), "getRecipes", true, false, false), GT_ModHandler.getEmptyCell(3));
        } catch(Throwable e) {}
        
    	GT_ModHandler.addSmeltingRecipe(GT_ModHandler.getIC2Item("hydratedCoalDust", 1), GT_OreDictUnificator.get("dustCoal", 1));
        GT_ModHandler.addCompressionRecipe(GT_ModHandler.getIC2Item("coalChunk", 1), GT_ModHandler.getIC2Item("industrialDiamond", 1));
		GT_ModHandler.addCompressionRecipe(new ItemStack(Block.sand, 4, 0), new ItemStack(Block.sandStone, 1, 0));
		GT_ModHandler.addCompressionRecipe(new ItemStack(Item.wheat, 8, 0), GT_ModHandler.getIC2Item("compressedPlantBall", 1));
		GT_ModHandler.addCompressionRecipe(new ItemStack(Item.reed, 8, 0), GT_ModHandler.getIC2Item("compressedPlantBall", 1));
		GT_ModHandler.addCompressionRecipe(new ItemStack(Block.cactus, 8, 0), GT_ModHandler.getIC2Item("compressedPlantBall", 1));
		GT_ModHandler.addCompressionRecipe(new ItemStack(Item.clay, 4, 0), new ItemStack(Block.blockClay, 1));
		GT_ModHandler.addCompressionRecipe(GT_MetaItem_Material.instance.getStack(8, 8), GT_ModHandler.getIC2Item("compressedPlantBall", 1));
		GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.glowStone, 1), GT_OreDictUnificator.get("dustGlowstone", 4), null, 0, false);
		GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.redstoneLampIdle, 1), GT_OreDictUnificator.get("dustGlowstone", 4), GT_OreDictUnificator.get("dustRedstone", 4), 90, false);
		GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.redstoneLampActive, 1), GT_OreDictUnificator.get("dustGlowstone", 4), GT_OreDictUnificator.get("dustRedstone", 4), 90, false);
		GT_ModHandler.addPulverisationRecipe(GT_ModHandler.getRCItem("cube.crushed.obsidian", 1), GT_OreDictUnificator.get("dustObsidian", 1), null, 0, true);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.reed, 1), new ItemStack(Item.sugar, 2), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.blockClay, 1), GT_OreDictUnificator.get("dustClay", 2), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.hardenedClay, 1), GT_OreDictUnificator.get("dustClay", 1), GT_OreDictUnificator.get("dustClay", 1), 50, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.stainedClay, 1), GT_OreDictUnificator.get("dustClay", 1), GT_OreDictUnificator.get("dustClay", 1), 50, false);
		GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.blockSnow, 1), new ItemStack(Item.snowball, 4), null, 0, false);
	    GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.stick, 1), GT_MetaItem_SmallDust.instance.getStack(15, 2), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.melon, 1, 0), new ItemStack(Item.melon, 8, 0), new ItemStack(Item.melonSeeds, 1), 80, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.pumpkin, 1, 0), new ItemStack(Item.pumpkinSeeds, 4, 0), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.melon, 1, 0), new ItemStack(Item.melonSeeds, 1, 0), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.wheat, 1, 0), GT_OreDictUnificator.get("dustWheat", 1), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(GT_ModHandler.getIC2Item("plantBall", 1), new ItemStack(Block.dirt, 1, 0), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(GT_ModHandler.getIC2Item("crop", 1), GT_OreDictUnificator.get("dustWood", 1), null, 0, false);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.eyeOfEnder, 1)	, GT_MetaItem_Dust.instance.getStack( 1, 2), null, 0, true);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Item.flint, 1)		, GT_MetaItem_SmallDust.instance.getStack( 7, 2), GT_MetaItem_SmallDust.instance.getStack( 7, 1), 10, true);
        GT_ModHandler.addPulverisationRecipe(new ItemStack(Block.cloth, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Item.silk, 2), new ItemStack(Item.silk, 1), 50, false);
		GT_ModHandler.addLiquidTransposerEmptyRecipe(GT_ModHandler.getIC2Item("hydratedCoalDust", 1), GT_ModHandler.getWater(125), GT_OreDictUnificator.get("dustCoal", 1), 125);
        GT_ModHandler.addExtractionRecipe(GT_ModHandler.getIC2Item("airCell", 1), GT_ModHandler.getEmptyCell(1));
        GT_ModHandler.addExtractionRecipe(GT_ModHandler.getAirCell(1), GT_ModHandler.getEmptyCell(1));
        GT_ModHandler.addExtractionRecipe(GT_ModHandler.getIC2Item("filledTinCan", 1, 0), GT_ModHandler.getIC2Item("tinCan", 1));
        GT_ModHandler.addExtractionRecipe(GT_ModHandler.getIC2Item("filledTinCan", 1, 1), GT_ModHandler.getIC2Item("tinCan", 1));
        GT_ModHandler.addExtractionRecipe(GT_MetaItem_Material.instance.getStack(8, 1), GT_MetaItem_Material.instance.getStack(9, 1));
        GT_ModHandler.addExtractionRecipe(new ItemStack(Block.cloth, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Block.cloth, 1, 0));
    	GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Carbon, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Hydrogen, 4), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Methane, 5), 3500);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Nitrogen, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Carbon, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.NitroCarbon, 2), 1500);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Calcium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Carbon, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Calcite, 2), 250);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Glyceryl, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.CoalFuel, 4), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.NitroCoalFuel, 5), 250);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Glyceryl, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Fuel, 4), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.NitroFuel, 5), 250);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Nitrogen, 1), GT_ModHandler.getAirCell(1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.NitrogenDioxide, 2), 1250);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.SodiumSulfide, 2), GT_ModHandler.getAirCell(2), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.SodiumPersulfate, 4), 4000);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.NitroCarbon, 3), GT_ModHandler.getWaterCell(3), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Glyceryl, 6), 1750);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Sulfur, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Sodium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.SodiumSulfide, 2), 100);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Sulfur, 1), GT_ModHandler.getWaterCell(2), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.SulfuricAcid, 3), 1150);
		GregTech_API.sRecipeAdder.addChemicalRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Hydrogen, 4), GT_ModHandler.getAirCell(1), GT_ModHandler.getWaterCell(5), 10);
        GregTech_API.sRecipeAdder.addFusionReactorRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Deuterium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Tritium, 1), GT_OreDictUnificator.get(OrePrefixes.cellPlasma, Materials.Helium, 1), 128, -4096, 40000000);
    	GregTech_API.sRecipeAdder.addFusionReactorRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Deuterium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium_3, 1), GT_OreDictUnificator.get(OrePrefixes.cellPlasma, Materials.Helium, 1), 128, -2048, 60000000);
    	GregTech_API.sRecipeAdder.addFusionReactorRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Lithium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Tungsten, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Iridium, 1), 512, -32768, 150000000);
		GregTech_API.sRecipeAdder.addFusionReactorRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Beryllium, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Tungsten, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Platinum, 1), 512, -32768, 100000000);
		GregTech_API.sRecipeAdder.addImplosionRecipe(GT_MetaItem_Material.instance.getStack(4, 1), 8, GT_OreDictUnificator.get(OrePrefixes.plateAlloy.get("Iridium"), 1), GT_OreDictUnificator.get("dustDarkAsh", 4));
        GregTech_API.sRecipeAdder.addImplosionRecipe(GT_ModHandler.getIC2Item("coalChunk", 1), 8, GT_ModHandler.getIC2Item("industrialDiamond", 1), GT_OreDictUnificator.get("dustDarkAsh", 4));
        GregTech_API.sRecipeAdder.addBenderRecipe(GT_ModHandler.getIC2Item("mixedMetalIngot", 1), GT_OreDictUnificator.getFirstOre("plateAlloyAdvanced", 1), 100, 8);
        GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 3), new ItemStack(Item.bucketEmpty, 1, 0), 200, 4);
		GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Aluminium, 3), GT_ModHandler.getRCItem("part.rail.standard", 1), 150, 10);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Iron, 3), GT_ModHandler.getRCItem("part.rail.standard", 2), 150, 10);
		GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Bronze, 2), GT_ModHandler.getRCItem("part.rail.standard", 1),  50, 20);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Steel, 3), GT_ModHandler.getRCItem("part.rail.standard", 4), 150, 30);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.StainlessSteel, 2), GT_ModHandler.getRCItem("part.rail.standard", 4), 150, 30);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Titanium, 3), GT_ModHandler.getRCItem("part.rail.standard", 8), 150, 30);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Tungsten, 3), GT_ModHandler.getRCItem("part.rail.standard", 8), 150, 30);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.TungstenSteel, 1), GT_ModHandler.getRCItem("part.rail.reinforced", 4), 100, 30);
    	GregTech_API.sRecipeAdder.addBenderRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Tin, GregTech_API.sTinCellCountPer4Ingots%4==0?1:4), GT_ModHandler.getEmptyCell(GregTech_API.sTinCellCountPer4Ingots%4==0?GregTech_API.sTinCellCountPer4Ingots/4:GregTech_API.sTinCellCountPer4Ingots), GregTech_API.sTinCellCountPer4Ingots%4==0?400:1600, 2);
	    GregTech_API.sRecipeAdder.addDistillationRecipe(GT_MetaItem_Cell.instance.getStack(17, 16), 33, GT_MetaItem_Cell.instance.getStack(18, 16), GT_MetaItem_Cell.instance.getStack(40, 16), GT_MetaItem_Cell.instance.getStack(34, 1), GT_MetaItem_Cell.instance.getStack(9, 16), 16000, 16);
        GregTech_API.sRecipeAdder.addDistillationRecipe(GT_MetaItem_Cell.instance.getStack(20, 16), 0, GT_MetaItem_Cell.instance.getStack(19,  8), null, null, GT_ModHandler.getEmptyCell(8), 400, 16);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(GT_ModHandler.getIC2Item("electrolyzedWaterCell", 6), 0, GT_MetaItem_Cell.instance.getStack(0, 4), GT_ModHandler.getIC2Item("airCell", 1), null, GT_ModHandler.getEmptyCell(1), 100, 30);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(GT_ModHandler.getWaterCell(1), 0, GT_ModHandler.getIC2Item("electrolyzedWaterCell", 1), null, null, null, 215, 120);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(GT_ModHandler.getIC2Item("waterCell", 1), 0, GT_ModHandler.getIC2Item("electrolyzedWaterCell", 1), null, null, null, 215, 120);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(new ItemStack(Item.bucketWater, 1), 1, GT_ModHandler.getIC2Item("electrolyzedWaterCell", 1), null, null, new ItemStack(Item.bucketEmpty, 1), 215, 120);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(new ItemStack(Item.dyePowder, 3, 15), 1, GT_MetaItem_Cell.instance.getStack(11, 1), null, null, null, 24, 106);
        GregTech_API.sRecipeAdder.addElectrolyzerRecipe(new ItemStack(Block.sand, 16), 2, GT_MetaItem_Cell.instance.getStack(7, 1), GT_ModHandler.getAirCell(1), null, null, 1000, 25);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GT_ModHandler.getIC2Item("reactorCoolantSimple"	, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_ModHandler.getIC2Item("reactorCoolantSimple"	, 1), 100);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GT_ModHandler.getIC2Item("reactorCoolantTriple"	, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_ModHandler.getIC2Item("reactorCoolantTriple"	, 1), 300);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GT_ModHandler.getIC2Item("reactorCoolantSix"		, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_ModHandler.getIC2Item("reactorCoolantSix"		, 1), 600);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(34, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(34, 1, 0),  700);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(35, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(35, 1, 0), 2000);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(36, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(36, 1, 0), 3900);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(60, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(60, 1, 0),  500);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(61, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(61, 1, 0), 1500);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GregTech_API.getGregTechItem(62, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GregTech_API.getGregTechItem(62, 1, 0), 3000);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GT_ModHandler.getWaterCell(1), GT_MetaItem_Cell.instance.getStack(23, 1), 50);
        GregTech_API.sRecipeAdder.addVacuumFreezerRecipe(GT_ModHandler.getIC2Item("waterCell", 1), GT_MetaItem_Cell.instance.getStack(23, 1), 50);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_MetaItem_Cell.instance.getStack(23, 1), 0, new ItemStack(Block.ice, 1), null, null, GT_ModHandler.getEmptyCell(1), 40);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.magmaCream, 1), 0, new ItemStack(Item.blazePowder, 1), new ItemStack(Item.slimeBall, 1), null, null, 500);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Hydrogen		,  4), 0, GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Deuterium	, 1), null, null, GT_ModHandler.getEmptyCell( 3),  3000);
    	GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium		, 16), 0, GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium_3		, 1), null, null, GT_ModHandler.getEmptyCell(15), 10000);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Deuterium	,  4), 0, GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Tritium		, 1), null, null, GT_ModHandler.getEmptyCell( 3),  3000);
    	GregTech_API.sRecipeAdder.addGrinderRecipe(new ItemStack(Block.netherrack, 16), GT_ModHandler.getWaterCell(1), new ItemStack(Item.goldNugget, 1), GT_MetaItem_Dust.instance.getStack(6, 16), null, GT_ModHandler.getEmptyCell(1));
        GregTech_API.sRecipeAdder.addGrinderRecipe(new ItemStack(Block.netherrack, 8), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Mercury, 1), new ItemStack(Item.goldNugget, 1), GT_MetaItem_Dust.instance.getStack(6, 8), null, GT_ModHandler.getEmptyCell(1));
		GregTech_API.sRecipeAdder.addCannerRecipe(GT_MetaItem_Material.instance.getStack(7, 4), GT_ModHandler.getEmptyCell(1), GT_MetaItem_Cell.instance.getStack(17, 1), null, 100, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(GT_ModHandler.getIC2Item("compressedPlantBall", 1), GT_ModHandler.getEmptyCell(1), GT_ModHandler.getIC2Item("bioCell", 1), null, 100, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(GT_ModHandler.getIC2Item("hydratedCoalClump", 1), GT_ModHandler.getEmptyCell(1), GT_ModHandler.getIC2Item("hydratedCoalCell", 1), null, 100, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(GT_ModHandler.getIC2Item("biofuelCell", 6), GT_ModHandler.getEmptyFuelCan(1), GT_ModHandler.getFuelCan(26040), GT_ModHandler.getEmptyCell(6), 600, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(GT_ModHandler.getIC2Item("coalfuelCell", 6), GT_ModHandler.getEmptyFuelCan(1), GT_ModHandler.getFuelCan(76440), GT_ModHandler.getEmptyCell(6), 600, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(new ItemStack(Item.bucketLava), GT_ModHandler.getEmptyCell(1), GT_ModHandler.getLavaCell(1), new ItemStack(Item.bucketEmpty, 1), 100, 1);
		GregTech_API.sRecipeAdder.addCannerRecipe(new ItemStack(Item.bucketWater), GT_ModHandler.getEmptyCell(1), GT_ModHandler.getWaterCell(1), new ItemStack(Item.bucketEmpty, 1), 100, 1);
		if (null == GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Silicon, 1))
		GregTech_API.sRecipeAdder.addBlastRecipe(GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Silicon, 2), null, GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Silicon, 1), GT_ModHandler.getEmptyCell(2), 1000, 120, 1500);
		GregTech_API.sRecipeAdder.addBlastRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Iron, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Coal, 2), GT_OreDictUnificator.get("ingotSteel", 1), GT_OreDictUnificator.get("dustDarkAsh", 2), 500, 120, 1000);
		GregTech_API.sRecipeAdder.addBlastRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Tungsten, 1), GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Steel, 1), GT_OreDictUnificator.get(OrePrefixes.ingotHot, Materials.TungstenSteel, 2), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.DarkAsh, 4), 500, 500, 3000);
		GregTech_API.sRecipeAdder.addBlastRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Galena, 2), null, GT_OreDictUnificator.get("ingotSilver", 1), GT_OreDictUnificator.get("ingotLead", 1), 20, 120, 1500);
		GregTech_API.sRecipeAdder.addBlastRecipe(GT_OreDictUnificator.get(OrePrefixes.gem, Materials.Galena, 2), null, GT_OreDictUnificator.get("ingotSilver", 1), GT_OreDictUnificator.get("ingotLead", 1), 16, 120, 1500);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("compressedCoalBall", 8), new ItemStack(Block.brick, 1), GT_ModHandler.getIC2Item("coalChunk", 1), 400, 4);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_MetaItem_Component.instance.getStack(49, 1), GT_MetaItem_Component.instance.getStack(24, 2), GT_ModHandler.getIC2Item("advancedCircuit", 1), 1600, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_MetaItem_Component.instance.getStack(50, 1), GT_MetaItem_Component.instance.getStack(3, 1), GT_MetaItem_Component.instance.getStack(1, 1), 3200, 4);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_MetaItem_Component.instance.getStack(50, 1), GT_ModHandler.getIC2Item("lapotronCrystal", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(0, 1), 3200, 4);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_MetaItem_Component.instance.getStack( 1, 1), GT_MetaItem_Component.instance.getStack(3, 8), GregTech_API.getGregTechItem(43, 1, 0), 12800, 16);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(new ItemStack(GregTech_API.sBlockList[1], 1, 6), GT_MetaItem_Component.instance.getStack(3, 4), GregTech_API.getGregTechItem(32, 1, 0), 6400, 8);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("waterMill", 2), null, GT_ModHandler.getIC2Item("generator", 1), 6400, 8);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(new ItemStack(Block.stoneSingleSlab, 3, 0), GT_ModHandler.getRCItem("part.rebar", 1), GT_ModHandler.getRCItem("part.tie.stone", 1), 128, 8);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(new ItemStack(Block.stoneSingleSlab, 3, 7), GT_ModHandler.getRCItem("part.rebar", 1), GT_ModHandler.getRCItem("part.tie.stone", 1), 128, 8);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GregTech_API.getGregTechItem(58, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), null, GregTech_API.getGregTechItem(56, 6, 0), 3200, 4);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("batPack", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), null, GT_ModHandler.getIC2Item("reBattery", 6), 1600, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("hvTransformer", 1)	, GT_ModHandler.getIC2Item("transformerUpgrade", 1), GT_MetaItem_Component.instance.getStack(27, 1), 3200, 4);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getTEItem("energyCellFrameFull", 1), GT_ModHandler.getIC2Item("energyStorageUpgrade", 1), GT_MetaItem_Component.instance.getStack(28, 4), 6400, 8);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getRCItem("part.tie.wood" , 4)	, null, GT_ModHandler.getRCItem("part.railbed.wood" , 1), 800, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getRCItem("part.tie.stone", 4)	, null, GT_ModHandler.getRCItem("part.railbed.stone", 1), 800, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.wood" , 1), tStack = GT_ModHandler.getRCItem("part.rail.standard"	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.wood" , 1), tStack = GT_ModHandler.getRCItem("part.rail.advanced"	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.wood" , 1), tStack = GT_ModHandler.getRCItem("part.rail.reinforced"	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.wood" , 1), tStack = GT_ModHandler.getRCItem("part.rail.speed"		, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.wood" , 1), tStack = GT_ModHandler.getRCItem("part.rail.wood"		, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.stone", 1), tStack = GT_ModHandler.getRCItem("part.rail.standard" 	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.stone", 1), tStack = GT_ModHandler.getRCItem("part.rail.advanced"	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.stone", 1), tStack = GT_ModHandler.getRCItem("part.rail.reinforced"	, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.stone", 1), tStack = GT_ModHandler.getRCItem("part.rail.speed" 		, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(tStack2 = GT_ModHandler.getRCItem("part.railbed.stone", 1), tStack = GT_ModHandler.getRCItem("part.rail.wood" 		, 6), GT_ModHandler.getRecipeOutput(new ItemStack[] {tStack, null, tStack, tStack, tStack2, tStack, tStack, null, tStack}), 1600, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_MetaItem_Component.instance.getStack(5, 1), GT_MetaItem_Component.instance.getStack(6, 1), GT_MetaItem_Component.instance.getStack(8, 1), 3200, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("carbonFiber", 2), null, GT_ModHandler.getIC2Item("carbonMesh", 1), 800, 2);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("carbonMesh", 16), null, GregTech_API.getGregTechItem(85, 1, 0), 1600, 8);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.getIC2Item("electronicCircuit", 1), GT_ModHandler.getIC2Item("frequencyTransmitter", 1), GregTech_API.getGregTechItem(17, 1, 0), 1600, 2);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GregTech_API.getGregTechItem(16, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), null, GT_ModHandler.getIC2Item("electronicCircuit", 2), 1600, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 5), new ItemStack(Block.chestTrapped, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Block.hopperBlock), 800, 2);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_ModHandler.getIC2Item("pump", 1), GT_MetaItem_Component.instance.getStack(6, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), new ItemStack(Block.pressurePlateIron, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(11, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), new ItemStack(Block.pressurePlateGold, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(10, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_ModHandler.getIC2Item("ecMeter", 1), GT_MetaItem_Component.instance.getStack(15, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 2), new ItemStack(Block.fenceIron, 2), GT_MetaItem_Component.instance.getStack(9, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), new ItemStack(Block.lever, 1), GT_MetaItem_Component.instance.getStack(31, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), new ItemStack(Block.workbench, 1), GT_MetaItem_Component.instance.getStack(64, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_ModHandler.getIC2Item("energyCrystal", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(12, 1), 1600, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_ModHandler.getIC2Item("lapotronCrystal", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(13, 1), 3200, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GregTech_API.getGregTechItem(37, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(14, 1), 6400, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 2), GT_ModHandler.getIC2Item("electronicCircuit", 1), GT_MetaItem_Component.instance.getStack(22, 3), 800, 16);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 4), GT_ModHandler.getIC2Item("generator", 1), GT_ModHandler.getIC2Item("waterMill", 2), 6400, 8);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Electrum, 2), GT_MetaItem_Component.instance.getStack(48, 2), 800, 1);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iridium, 1), GT_MetaItem_Component.instance.getStack(88, 1), 1600, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_MetaItem_Component.instance.getStack(86, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 5), new ItemStack(Block.chest, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Block.hopperBlock), 800, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 5), new ItemStack(Block.chestTrapped, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Block.hopperBlock), 800, 2);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_ModHandler.getIC2Item("pump", 1), GT_MetaItem_Component.instance.getStack(6, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), new ItemStack(Block.pressurePlateIron, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(11, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), new ItemStack(Block.pressurePlateGold, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(10, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_ModHandler.getIC2Item("ecMeter", 1), GT_MetaItem_Component.instance.getStack(15, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 2), new ItemStack(Block.fenceIron, 2), GT_MetaItem_Component.instance.getStack(9, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), new ItemStack(Item.comparator, 1), GT_MetaItem_Component.instance.getStack(30, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), new ItemStack(Block.lever, 1), GT_MetaItem_Component.instance.getStack(31, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), new ItemStack(Block.workbench, 1), GT_MetaItem_Component.instance.getStack(64, 1), 800, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_ModHandler.getIC2Item("energyCrystal", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(12, 1), 1600, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_ModHandler.getIC2Item("lapotronCrystal", 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(13, 1), 3200, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GregTech_API.getGregTechItem(37, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(14, 1), 6400, 16);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 2), GT_ModHandler.getIC2Item("electronicCircuit", 1), GT_MetaItem_Component.instance.getStack(22, 4), 800, 16);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Electrum, 2), GT_MetaItem_Component.instance.getStack(48, 2), 800, 1);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iridium, 1), GT_MetaItem_Component.instance.getStack(88, 1), 1600, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_MetaItem_Component.instance.getStack(86, 1), 800, 16);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Electrum, 2), GT_ModHandler.getIC2Item("electronicCircuit", 1), GT_MetaItem_Component.instance.getStack(49, 1), 1600, 2);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Electrum, 4), GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Silicon, 1), GT_MetaItem_Component.instance.getStack(49, 2), 1600, 2);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Platinum, 1), GT_ModHandler.getIC2Item("advancedCircuit", 1), GT_MetaItem_Component.instance.getStack(50, 1), 3200, 4);
   	   	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Magnalium, 2), GT_ModHandler.getIC2Item("generator", 1), GT_ModHandler.getIC2Item("windMill", 1), 6400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.TungstenSteel, 1), GT_ModHandler.getIC2Item("reinforcedStone", 1), new ItemStack(GregTech_API.sBlockList[4], 1, 8), 400, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.TungstenSteel, 1), new ItemStack(GregTech_API.sBlockList[0], 1, 2), new ItemStack(GregTech_API.sBlockList[4], 1, 9), 400, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iridium, 1), GT_ModHandler.getIC2Item("reinforcedStone", 1), new ItemStack(GregTech_API.sBlockList[0], 1, 2), 400, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iridium, 1), new ItemStack(GregTech_API.sBlockList[4], 1, 8), new ItemStack(GregTech_API.sBlockList[4], 1, 9), 400, 4);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Steel, 2), GT_ModHandler.getRCItem("machine.beta.engine.steam.high", 1, GregTech_API.getGregTechBlock(1, 1, 34)), GT_MetaItem_Component.instance.getStack(80, 1), 1600, 32);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Steel, 2), new ItemStack(Block.thinGlass, 1, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_MetaItem_Component.instance.getStack(81, 1), 1600, 32);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Emerald, 8), GT_ModHandler.getIC2Item("advancedCircuit", 1), GT_MetaItem_Component.instance.getStack(3, 4), 6400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Olivine, 8), GT_ModHandler.getIC2Item("advancedCircuit", 1), GT_MetaItem_Component.instance.getStack(3, 4), 6400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.gem  , Materials.EnderPearl, 1), new ItemStack(Item.blazePowder, 1, 0), new ItemStack(Item.eyeOfEnder, 1, 0),  400, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.gem  , Materials.EnderPearl, 6), new ItemStack(Item.blazeRod   , 1, 0), new ItemStack(Item.eyeOfEnder, 6, 0), 2500, 2);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Aluminium		, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(32, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Bronze			, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(33, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Brass			, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(34, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Steel			, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(35, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Titanium			, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(36, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron				, 8), GT_MetaItem_Component.instance.getStack(22, 1), GT_ModHandler.getIC2Item("machine", 1, GT_MetaItem_Component.instance.getStack(37, 1)), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.TungstenSteel	, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(38, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.StainlessSteel	, 6), GT_MetaItem_Component.instance.getStack(22, 1), GT_MetaItem_Component.instance.getStack(39, 1), 400, 8);
   		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron				, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Iron			, 4), GT_MetaItem_Component.instance.getStack( 96, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Bronze			, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Bronze			, 4), GT_MetaItem_Component.instance.getStack( 97, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Steel			, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Steel			, 4), GT_MetaItem_Component.instance.getStack( 98, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Titanium			, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Titanium		, 4), GT_MetaItem_Component.instance.getStack( 99, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.TungstenSteel	, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.TungstenSteel	, 4), GT_MetaItem_Component.instance.getStack(100, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iridium			, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Iridium			, 4), GT_MetaItem_Component.instance.getStack(101, 1), 3200, 4);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.StainlessSteel	, 4), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.StainlessSteel	, 4), GT_MetaItem_Component.instance.getStack(102, 1), 3200, 4);
	    // TODO: GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Iron, 3), null, new ItemStack(Block.fenceIron, 4), 400, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCGoldGear, GT_OreDictUnificator.get(OrePrefixes.gem	, Materials.Diamond, 4), GT_ModHandler.mBCDiamondGear, 1600, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCGoldGear, GT_OreDictUnificator.get(OrePrefixes.plate	, Materials.Diamond, 4), GT_ModHandler.mBCDiamondGear, 1600, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCIronGear, GT_OreDictUnificator.get(OrePrefixes.ingot	, Materials.Gold, 4), GT_ModHandler.mBCGoldGear, 800, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCIronGear, GT_OreDictUnificator.get(OrePrefixes.plate	, Materials.Gold, 4), GT_ModHandler.mBCGoldGear, 800, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCStoneGear, GT_OreDictUnificator.get(OrePrefixes.ingot	, Materials.Iron, 4), GT_ModHandler.mBCIronGear, 400, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_ModHandler.mBCStoneGear, GT_OreDictUnificator.get(OrePrefixes.plate	, Materials.Iron, 4), GT_ModHandler.mBCIronGear, 400, 2);
	    GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Flint, 5), new ItemStack(Block.tnt, 3, GregTech_API.ITEM_WILDCARD_DAMAGE), GT_ModHandler.getIC2Item("industrialTnt", 5), 800, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Gunpowder, 4), new ItemStack(Block.sand, 4, GregTech_API.ITEM_WILDCARD_DAMAGE), new ItemStack(Block.tnt, 1), 400, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Glowstone, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Lapis, 1), GT_MetaItem_Component.instance.getStack(24, 2), 800, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Glowstone, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Lazurite, 1), GT_MetaItem_Component.instance.getStack(24, 2), 800, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_ModHandler.getEmptyCell(1), GT_MetaItem_Component.instance.getStack(56, 1), 800, 2);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 4), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Glowstone, 4), new ItemStack(Block.redstoneLampIdle, 1), 400, 1);
		GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Wood, 1), new ItemStack(Block.torchRedstoneActive, 1), 400, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Iron, 4), new ItemStack(Item.compass, 1), 400, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Gold, 4), new ItemStack(Item.pocketSundial, 1), 400, 4);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.stick, Materials.Wood, 1), GT_ModHandler.getIC2Item("resin", 1), new ItemStack(Block.torchWood, 6), 400, 1);
    	GregTech_API.sRecipeAdder.addAssemblerRecipe(GT_OreDictUnificator.get(OrePrefixes.dust , Materials.Coal, 8), new ItemStack(Item.flint, 1), GT_ModHandler.getIC2Item("compressedCoalBall", 1), 400, 4);
    	GregTech_API.sRecipeAdder.addCutterRecipe(new ItemStack(Block.woodSingleSlab, 1, 0), GT_MetaItem_Material.instance.getStack(60, 2), 50, 8);
    	GregTech_API.sRecipeAdder.addCutterRecipe(new ItemStack(Block.woodSingleSlab, 1, 1), GT_MetaItem_Material.instance.getStack(61, 2), 50, 8);
    	GregTech_API.sRecipeAdder.addCutterRecipe(new ItemStack(Block.woodSingleSlab, 1, 2), GT_MetaItem_Material.instance.getStack(62, 2), 50, 8);
    	GregTech_API.sRecipeAdder.addCutterRecipe(new ItemStack(Block.woodSingleSlab, 1, 3), GT_MetaItem_Material.instance.getStack(63, 2), 50, 8);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Iron	, 1), GT_ModHandler.getIC2Item("casingiron"		, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Gold	, 1), GT_ModHandler.getIC2Item("casinggold"		, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Bronze	, 1), GT_ModHandler.getIC2Item("casingbronze"	, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Copper	, 1), GT_ModHandler.getIC2Item("casingcopper"	, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Tin		, 1), GT_ModHandler.getIC2Item("casingtin"		, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addCutterRecipe(GT_OreDictUnificator.get(OrePrefixes.plate, Materials.Lead	, 1), GT_ModHandler.getIC2Item("casinglead"		, 2), 50, 16);
    	GregTech_API.sRecipeAdder.addAlloySmelterRecipe(new ItemStack(Item.bucketWater, 1, 0), null, new ItemStack(Item.bucketEmpty, 1, 0), 100, 1);
        GregTech_API.sRecipeAdder.addAlloySmelterRecipe(new ItemStack(Item.bucketMilk, 1, 0), null, new ItemStack(Item.bucketEmpty, 1, 0), 100, 1);
		GregTech_API.sRecipeAdder.addAlloySmelterRecipe(GT_OreDictUnificator.get(OrePrefixes.dust , Materials.Lead, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Obsidian, 2), GT_ModHandler.getTEItem("hardenedGlass", 2), 200, 16);
		GregTech_API.sRecipeAdder.addAlloySmelterRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Lead, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Obsidian, 2), GT_ModHandler.getTEItem("hardenedGlass", 2), 200, 16);
        GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Copper, 1), GT_ModHandler.getIC2Item("copperCableItem", 3), 100, 2);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Tin, 1), GT_ModHandler.getIC2Item("tinCableItem", 4), 150, 1);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.SolderingAlloy, 1), GregTech_API.getGregTechItem(78, 1, 0), 100, 4);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Iron, 1), GT_ModHandler.getIC2Item("ironCableItem", 6), 200, 2);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Gold, 1), GT_ModHandler.getIC2Item("goldCableItem", 6), 200, 1);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Lead, 1), GregTech_API.getGregTechItem(79, 1, 0), 100, 4);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Kanthal, 4), GT_MetaItem_Component.instance.getStack(19, 1), 450, 12);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Nichrome, 5), GT_MetaItem_Component.instance.getStack(20, 1), 600, 16);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Cupronickel, 3), GT_MetaItem_Component.instance.getStack(21, 1), 300,  8);
    	GregTech_API.sRecipeAdder.addWiremillRecipe(GT_OreDictUnificator.get(OrePrefixes.dust , Materials.Coal, 4), GT_ModHandler.getIC2Item("carbonFiber", 1), 400, 2);
    	
    	GT_ModHandler.removeRecipe(new ItemStack[] {new ItemStack(Item.bucketLava), GT_ModHandler.getEmptyCell(1)});
		GT_ModHandler.removeRecipe(new ItemStack[] {new ItemStack(Item.bucketWater), GT_ModHandler.getEmptyCell(1)});
		GT_ModHandler.removeRecipe(new ItemStack[] {GT_ModHandler.getIC2Item("uraniumIngot", 1), GT_ModHandler.getEmptyCell(1)});
		GT_ModHandler.removeRecipe(new ItemStack[] {GT_ModHandler.getIC2Item("compressedPlantBall", 1), GT_ModHandler.getEmptyCell(1)});
		GT_ModHandler.removeRecipe(new ItemStack[] {GT_ModHandler.getIC2Item("hydratedCoalClump", 1), GT_ModHandler.getEmptyCell(1)});
		
		GT_ModHandler.removeFurnaceSmelting(GT_ModHandler.getIC2Item("resin", 1), null);
		
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_ModHandler.getIC2Item("nearDepletedUraniumCell", 1), 0, GT_OreDictUnificator.get("dustThorium", 1), null, null, GT_ModHandler.getEmptyCell(1), 500);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_ModHandler.getIC2Item("reEnrichedUraniumCell", 8), 0, GT_ModHandler.getIC2Item("nearDepletedUraniumCell", 3), GT_OreDictUnificator.get("dustPlutonium", 1), GT_OreDictUnificator.get("dustThorium", 4), GT_ModHandler.getEmptyCell(5), 20000);
    	
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.dirt, 16), 0, GT_ModHandler.getIC2Item("compressedPlantBall", 1), GT_ModHandler.getIC2Item("plantBall", 1), new ItemStack(Item.clay, 1), new ItemStack(Block.sand, 8), 2500);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.grass, 16), 0, GT_ModHandler.getIC2Item("compressedPlantBall", 2), GT_ModHandler.getIC2Item("plantBall", 2), new ItemStack(Item.clay, 1), new ItemStack(Block.sand, 8), 2500);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.mycelium, 8), 0, new ItemStack(Block.mushroomBrown, 2), new ItemStack(Block.mushroomRed, 2), new ItemStack(Item.clay, 1), new ItemStack(Block.sand, 4), 1650);
        
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.appleGold		,  1, 1), 2, GT_MetaItem_Cell.instance.getStack(9, 2), new ItemStack(Item.ingotGold, 64), null, null, 10000);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.appleGold		,  1, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), new ItemStack(Item.ingotGold, 7), null, null, 10000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.goldenCarrot	,  1, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), new ItemStack(Item.goldNugget, 6), null, null, 10000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.speckledMelon	,  1, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), new ItemStack(Item.goldNugget, 6), null, null, 10000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.appleRed		, 32, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.bowlSoup		, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.bread			, 64, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.porkRaw		, 12, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.porkCooked		, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.beefRaw		, 12, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.beefCooked		, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.fishRaw		, 12, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.fishCooked		, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.chickenRaw		, 12, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.chickenCooked	, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.melon			, 64, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.pumpkin		, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.rottenFlesh	, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.spiderEye		, 32, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.carrot			, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.potato			, 16, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.poisonousPotato, 12, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.bakedPotato	, 24, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.cookie			, 64, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.cake			,  8, 0), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null,  5000);
        
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.mushroomCapBrown	, 12, GregTech_API.ITEM_WILDCARD_DAMAGE), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.mushroomCapRed		, 12, GregTech_API.ITEM_WILDCARD_DAMAGE), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.mushroomBrown		, 32), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.mushroomRed		, 32), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.netherStalkSeeds	, 32), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_ModHandler.getIC2Item("terraWart"	, 16), 1, GT_MetaItem_Cell.instance.getStack(9, 1), null, null, null, 5000);
        
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_ModHandler.getIC2Item("resin", 4), 0, GT_OreDictUnificator.get("itemRubber", 14), GT_ModHandler.getIC2Item("compressedPlantBall", 1), GT_ModHandler.getIC2Item("plantBall", 1), null, 1300);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Block.slowSand, 16), 1, GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Oil, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Saltpeter, 4), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Coal, 1), new ItemStack(Block.sand, 10), 2500);
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(new ItemStack(Item.bucketLava, 8), 0, GT_OreDictUnificator.get(OrePrefixes.nugget, Materials.Electrum, 4), GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Copper, 2), GT_OreDictUnificator.get(OrePrefixes.dustTiny, Materials.Tungsten, 1), GT_OreDictUnificator.get(OrePrefixes.ingot, Materials.Tin, 1), 5000);        
        GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Netherrack, 16), 0, GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 1), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Sulfur, 4), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Coal, 1), GT_OreDictUnificator.get(OrePrefixes.nugget, Materials.Gold, 1), 2400);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Endstone, 16), 2, GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium_3, 1), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium, 1), GT_OreDictUnificator.get(OrePrefixes.dustTiny, Materials.Tungsten, 1), new ItemStack(Block.sand, 12), 4800);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.DarkAsh, 2), 0, GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Ash, 1), GT_ModHandler.getTEItem("slag", 1, GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Ash, 1)), null, null, 250);
		GregTech_API.sRecipeAdder.addCentrifugeRecipe(GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Glowstone, 16), 1, GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Redstone, 8), GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Gold, 8), GT_OreDictUnificator.get(OrePrefixes.cell, Materials.Helium, 1), null, 25000);
		
        if (!GregTech_API.sConfiguration.addAdvConfig(GT_ConfigCategories.storageblockcrafting, "blockGlowstone", false)) GT_ModHandler.removeRecipe(new ItemStack[] {tStack = new ItemStack(Item.glowstone, 1), tStack, null, tStack, tStack, null, null, null, null});
        GT_ModHandler.addCompressionRecipe(new ItemStack(Item.glowstone, 4, 0), new ItemStack(Block.glowStone, 1));
        GT_ModHandler.addPulverisationRecipe(GT_ModHandler.getIC2Item("machine", 1), GT_OreDictUnificator.get("dustIron", 8), null, 0, false);
        GT_ModHandler.addSmeltingRecipe(GT_ModHandler.getIC2Item("machine", 1), GT_OreDictUnificator.get("ingotIron", 8));
        GT_ModHandler.addExtractionRecipe(new ItemStack(Item.slimeBall, 1), GT_OreDictUnificator.get("itemRubber", 2));
        GT_ModHandler.addSmeltingRecipe(new ItemStack(Item.slimeBall,1), GT_ModHandler.getIC2Item("resin", 1));
        GT_ModHandler.addExtractionRecipe(GT_ModHandler.getIC2Item("resin", 1), GT_OreDictUnificator.get("itemRubber", 3));
	}
}